<?
sapp_include_once('common.php');

function form_handler()
{
	$valid = true;

	// check ssl
	$ssl = sapp_get_submit_value('ssl');
	switch ($ssl) {
		case 'true':
			sapp_set_ssl(true);
			break;

		default:
			sapp_set_ssl(false);
			break;
	}

	// check install_prefix
	$install_prefix = sapp_get_submit_value('install_prefix');
	if (in_array($install_prefix, array(".", "/", "./")))
	{
		$ret = (function_exists('sapp_check_install_prefix'))? sapp_check_install_prefix(SITEAPP_PREFIX_ROOT) : false;
		if (false === $ret || false === in_array($ret, array(SITEAPP_DIR_NOT_EXISTS, SITEAPP_DIR_USED_BY_UNKNOWN)))
		{
			sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
			$valid = false;
		}
	}
	switch (sapp_set_install_prefix($install_prefix)) {

		case SITEAPP_DIR_NOT_EXISTS:
			break;

		case SITEAPP_DIR_USED_BY_UNKNOWN:
			sapp_set_wrong('install_prefix', msg('install_prefix__already_exists'));
			$valid = false;
			break;			

		case SITEAPP_DIR_INVALID_NAME:
			sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
			$valid = false;
			break;

		case SITEAPP_DIR_USED_BY_SITEAPP:
			sapp_set_wrong('install_prefix', msg('install_prefix__used_by_sapp'));
			$valid = false;
			break;
	}

	$mambo_admin_email = sapp_get_submit_value('mambo_admin_email');
	if (!check_email($mambo_admin_email)) {
		sapp_set_wrong('mambo_admin_email', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('mambo_admin_email', $mambo_admin_email);

	//check db name
	$mambo_dbname = sapp_get_submit_value('mambo_dbname');
	if (!check_dbName($mambo_dbname)) {
		sapp_set_wrong('mambo_dbname', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('mambo_dbname', $mambo_dbname);

	if ($valid == true && sapp_is_database_exists($mambo_dbname, 'mysql')) {
		sapp_set_wrong('mambo_dbname', msg('db__database_already_exists'));
		$valid = false;
	}
	
	//check db user
	$mambo_dbuser = sapp_get_submit_value('mambo_dbuser');
	if (!check_dbUserName($mambo_dbuser)) {
		sapp_set_wrong('mambo_dbuser', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('mambo_dbuser', $mambo_dbuser);

	//check db passwd
	$mambo_dbpasswd = sapp_get_submit_value('mambo_dbpasswd');
	$mambo_dbconfirm = sapp_get_submit_value('mambo_dbconfirm');
	if ('' == $mambo_dbpasswd) {
		if (!sapp_get_param('mambo_dbpasswd')) {
			sapp_set_wrong('mambo_dbpasswd', msg('password__empty'));
			$valid = false;
		} else {
			$mambo_dbpasswd = sapp_get_param('mambo_dbpasswd');
		}
	} elseif ($mambo_dbpasswd != $mambo_dbconfirm) {
		sapp_set_wrong('mambo_dbpasswd', msg('password__not_match'));
		sapp_set_wrong('mambo_dbconfirm', msg('password__not_match'));
		$valid = false;
	} elseif (!check_sys_passwd($mambo_dbuser, $mambo_dbpasswd)) {
		sapp_set_wrong('mambo_dbpasswd', msg('invalid_value'));
		$valid = false;
	} else {
		sapp_set_param('mambo_dbpasswd', $mambo_dbpasswd);
	}
	
	if ($valid == true && sapp_is_database_user_exists($mambo_dbname, 'mysql', $mambo_dbuser, $mambo_dbpasswd)) {
		sapp_set_wrong('mambo_dbuser', msg('db__database_user_already_exists'));
		$valid = false;
	}
	
	//check admin login
	$mambo_admin_login = sapp_get_submit_value('mambo_admin_login');
	if (!check_mambo_login($mambo_admin_login)) {
		sapp_set_wrong('mambo_admin_login', msg('invalid_mambo_login'));
		$valid = false;
	}
	
	sapp_set_param('mambo_admin_login', $mambo_admin_login);

	//check admin password
	$mambo_admin_passwd = sapp_get_submit_value('mambo_admin_passwd');
	$mambo_admin_confirm = sapp_get_submit_value('mambo_admin_confirm');
	if ('' == $mambo_admin_passwd) {
		if (!sapp_get_param('mambo_admin_passwd')) {
			sapp_set_wrong('mambo_admin_passwd', msg('password__empty'));
			$valid = false;
		} else {
			$mambo_admin_passwd = sapp_get_param('mambo_admin_passwd');
		}
	} elseif ($mambo_admin_passwd != $mambo_admin_confirm) {
		sapp_set_wrong('mambo_admin_passwd', msg('password__not_match'));
		sapp_set_wrong('mambo_admin_confirm', msg('password__not_match'));
		$valid = false;
	} elseif (!check_mambo_password($mambo_admin_login, $mambo_admin_passwd)) {
		sapp_set_wrong('mambo_admin_passwd', msg('invalid_value'));
		$valid = false;
	} else {
		sapp_set_param('mambo_admin_passwd', $mambo_admin_passwd);
	}
	
	//check editor login
	$mambo_editor_login = sapp_get_submit_value('mambo_editor_login');
	if (!check_mambo_login($mambo_editor_login)) {
		sapp_set_wrong('mambo_editor_login', msg('invalid_mambo_login'));
		$valid = false;
	}
	
	sapp_set_param('mambo_editor_login', $mambo_editor_login);

	//check admin password
	$mambo_editor_passwd = sapp_get_submit_value('mambo_editor_passwd');
	$mambo_editor_confirm = sapp_get_submit_value('mambo_editor_confirm');
	if ('' == $mambo_editor_passwd) {
		if (!sapp_get_param('mambo_editor_passwd')) {
			sapp_set_wrong('mambo_editor_passwd', msg('password__empty'));
			$valid = false;
		} else {
			$mambo_editor_passwd = sapp_get_param('mambo_editor_passwd');
		}
	} elseif ($mambo_editor_passwd != $mambo_editor_confirm) {
		sapp_set_wrong('mambo_editor_passwd', msg('password__not_match'));
		sapp_set_wrong('mambo_editor_confirm', msg('password__not_match'));
		$valid = false;
	} elseif (!check_mambo_password($mambo_editor_login, $mambo_editor_passwd)) {
		sapp_set_wrong('mambo_editor_passwd', msg('invalid_value'));
		$valid = false;
	} else {
		sapp_set_param('mambo_editor_passwd', $mambo_editor_passwd);
	}

	$mambo_editor_email = sapp_get_submit_value('mambo_editor_email');
	if (!check_email($mambo_editor_email)) {
		sapp_set_wrong('mambo_editor_email', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('mambo_editor_email', $mambo_editor_email);

	if (false === $valid) {
		sapp_set_warning(msg('invalid_values'));
		return 1;
	}
		
	if (!sapp_create_database($mambo_dbname, 'mysql')) {
		sapp_set_wrong('mambo_dbname', msg('db__unable_to_create'));
		return 1;
	}

	if (!sapp_create_database_user($mambo_dbname, 'mysql', $mambo_dbuser, $mambo_dbpasswd)) {
		sapp_set_wrong('mambo_dbuser', msg('db__unable_to_create'));
		return 1;
	}

	// set application URL
	sapp_set_param('application_url', sapp_get_param('install_prefix'));

	if ('yes' == sapp_get_param('site_builder_installation'))
		sapp_open_application_url();
		
	return 2;
}
?>
